<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Utils.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute</a> &gt; <span class="el_source">Utils.java</span></div><h1>Utils.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute;

import java.io.ByteArrayOutputStream;
import java.io.IOException;

/**
 * Various utility functions for Hadoop record I/O runtime.
 */
public class Utils {
    
    /** Cannot create a new instance of Utils */
    private Utils() {
<span class="nc" id="L31">        super();</span>
<span class="nc" id="L32">    }</span>
   
    /**
     * equals function that actually compares two buffers.
     *
     * @param onearray First buffer
     * @param twoarray Second buffer
     * @return true if one and two contain exactly the same content, else false.
     */
    public static boolean bufEquals(byte onearray[], byte twoarray[] ) {
<span class="nc bnc" id="L42" title="All 2 branches missed.">    	if (onearray == twoarray) return true;</span>
<span class="nc bnc" id="L43" title="All 2 branches missed.">        boolean ret = (onearray.length == twoarray.length);</span>
<span class="nc bnc" id="L44" title="All 2 branches missed.">        if (!ret) {</span>
<span class="nc" id="L45">            return ret;</span>
        }
<span class="nc bnc" id="L47" title="All 2 branches missed.">        for (int idx = 0; idx &lt; onearray.length; idx++) {</span>
<span class="nc bnc" id="L48" title="All 2 branches missed.">            if (onearray[idx] != twoarray[idx]) {</span>
<span class="nc" id="L49">                return false;</span>
            }
        }
<span class="nc" id="L52">        return true;</span>
    }
    
<span class="fc" id="L55">    private static final char[] hexchars = { '0', '1', '2', '3', '4', '5',</span>
                                            '6', '7', '8', '9', 'A', 'B',
                                            'C', 'D', 'E', 'F' };
    /**
     * 
     * @param s 
     * @return 
     */
    static String toXMLString(String s) {
<span class="nc bnc" id="L64" title="All 2 branches missed.">        if (s == null)</span>
<span class="nc" id="L65">            return &quot;&quot;;</span>

<span class="nc" id="L67">        StringBuilder sb = new StringBuilder();</span>
<span class="nc bnc" id="L68" title="All 2 branches missed.">        for (int idx = 0; idx &lt; s.length(); idx++) {</span>
<span class="nc" id="L69">          char ch = s.charAt(idx);</span>
<span class="nc bnc" id="L70" title="All 2 branches missed.">          if (ch == '&lt;') {</span>
<span class="nc" id="L71">            sb.append(&quot;&amp;lt;&quot;);</span>
<span class="nc bnc" id="L72" title="All 2 branches missed.">          } else if (ch == '&amp;') {</span>
<span class="nc" id="L73">            sb.append(&quot;&amp;amp;&quot;);</span>
<span class="nc bnc" id="L74" title="All 2 branches missed.">          } else if (ch == '%') {</span>
<span class="nc" id="L75">            sb.append(&quot;%25&quot;);</span>
<span class="nc bnc" id="L76" title="All 2 branches missed.">          } else if (ch &lt; 0x20) {</span>
<span class="nc" id="L77">            sb.append(&quot;%&quot;);</span>
<span class="nc" id="L78">            sb.append(hexchars[ch/16]);</span>
<span class="nc" id="L79">            sb.append(hexchars[ch%16]);</span>
          } else {
<span class="nc" id="L81">            sb.append(ch);</span>
          }
        }
<span class="nc" id="L84">        return sb.toString();</span>
    }
    
    static private int h2c(char ch) {
<span class="nc bnc" id="L88" title="All 4 branches missed.">      if (ch &gt;= '0' &amp;&amp; ch &lt;= '9') {</span>
<span class="nc" id="L89">        return ch - '0';</span>
<span class="nc bnc" id="L90" title="All 4 branches missed.">      } else if (ch &gt;= 'A' &amp;&amp; ch &lt;= 'F') {</span>
<span class="nc" id="L91">        return ch - 'A';</span>
<span class="nc bnc" id="L92" title="All 4 branches missed.">      } else if (ch &gt;= 'a' &amp;&amp; ch &lt;= 'f') {</span>
<span class="nc" id="L93">        return ch - 'a';</span>
      }
<span class="nc" id="L95">      return 0;</span>
    }
    
    /**
     * 
     * @param s 
     * @return 
     */
    static String fromXMLString(String s) {
<span class="nc" id="L104">        StringBuilder sb = new StringBuilder();</span>
<span class="nc bnc" id="L105" title="All 2 branches missed.">        for (int idx = 0; idx &lt; s.length();) {</span>
<span class="nc" id="L106">          char ch = s.charAt(idx++);</span>
<span class="nc bnc" id="L107" title="All 2 branches missed.">          if (ch == '%') {</span>
<span class="nc" id="L108">            char ch1 = s.charAt(idx++);</span>
<span class="nc" id="L109">            char ch2 = s.charAt(idx++);</span>
<span class="nc" id="L110">            char res = (char)(h2c(ch1)*16 + h2c(ch2));</span>
<span class="nc" id="L111">            sb.append(res);</span>
<span class="nc" id="L112">          } else {</span>
<span class="nc" id="L113">            sb.append(ch);</span>
          }
<span class="nc" id="L115">        }</span>
        
<span class="nc" id="L117">        return sb.toString();</span>
    }
    
    /**
     * 
     * @param s 
     * @return 
     */
    static String toCSVString(String s) {
<span class="fc bfc" id="L126" title="All 2 branches covered.">        if (s == null)</span>
<span class="fc" id="L127">            return &quot;&quot;;</span>

<span class="fc" id="L129">        StringBuilder sb = new StringBuilder(s.length()+1);</span>
<span class="fc" id="L130">        sb.append('\'');</span>
<span class="fc" id="L131">        int len = s.length();</span>
<span class="fc bfc" id="L132" title="All 2 branches covered.">        for (int i = 0; i &lt; len; i++) {</span>
<span class="fc" id="L133">            char c = s.charAt(i);</span>
<span class="pc bpc" id="L134" title="6 of 7 branches missed.">            switch(c) {</span>
                case '\0':
<span class="nc" id="L136">                    sb.append(&quot;%00&quot;);</span>
<span class="nc" id="L137">                    break;</span>
                case '\n':
<span class="nc" id="L139">                    sb.append(&quot;%0A&quot;);</span>
<span class="nc" id="L140">                    break;</span>
                case '\r':
<span class="nc" id="L142">                    sb.append(&quot;%0D&quot;);</span>
<span class="nc" id="L143">                    break;</span>
                case ',':
<span class="nc" id="L145">                    sb.append(&quot;%2C&quot;);</span>
<span class="nc" id="L146">                    break;</span>
                case '}':
<span class="nc" id="L148">                    sb.append(&quot;%7D&quot;);</span>
<span class="nc" id="L149">                    break;</span>
                case '%':
<span class="nc" id="L151">                    sb.append(&quot;%25&quot;);</span>
<span class="nc" id="L152">                    break;</span>
                default:
<span class="fc" id="L154">                    sb.append(c);</span>
            }
        }
<span class="fc" id="L157">        return sb.toString();</span>
    }
    
    /**
     * 
     * @param s 
     * @throws java.io.IOException 
     * @return 
     */
    static String fromCSVString(String s) throws IOException {
<span class="nc bnc" id="L167" title="All 2 branches missed.">        if (s.charAt(0) != '\'') {</span>
<span class="nc" id="L168">            throw new IOException(&quot;Error deserializing string.&quot;);</span>
        }
<span class="nc" id="L170">        int len = s.length();</span>
<span class="nc" id="L171">        StringBuilder sb = new StringBuilder(len-1);</span>
<span class="nc bnc" id="L172" title="All 2 branches missed.">        for (int i = 1; i &lt; len; i++) {</span>
<span class="nc" id="L173">            char c = s.charAt(i);</span>
<span class="nc bnc" id="L174" title="All 2 branches missed.">            if (c == '%') {</span>
<span class="nc" id="L175">                char ch1 = s.charAt(i+1);</span>
<span class="nc" id="L176">                char ch2 = s.charAt(i+2);</span>
<span class="nc" id="L177">                i += 2;</span>
<span class="nc bnc" id="L178" title="All 4 branches missed.">                if (ch1 == '0' &amp;&amp; ch2 == '0') { sb.append('\0'); }</span>
<span class="nc bnc" id="L179" title="All 4 branches missed.">                else if (ch1 == '0' &amp;&amp; ch2 == 'A') { sb.append('\n'); }</span>
<span class="nc bnc" id="L180" title="All 4 branches missed.">                else if (ch1 == '0' &amp;&amp; ch2 == 'D') { sb.append('\r'); }</span>
<span class="nc bnc" id="L181" title="All 4 branches missed.">                else if (ch1 == '2' &amp;&amp; ch2 == 'C') { sb.append(','); }</span>
<span class="nc bnc" id="L182" title="All 4 branches missed.">                else if (ch1 == '7' &amp;&amp; ch2 == 'D') { sb.append('}'); }</span>
<span class="nc bnc" id="L183" title="All 4 branches missed.">                else if (ch1 == '2' &amp;&amp; ch2 == '5') { sb.append('%'); }</span>
<span class="nc" id="L184">                else {throw new IOException(&quot;Error deserializing string.&quot;);}</span>
<span class="nc" id="L185">            } else {</span>
<span class="nc" id="L186">                sb.append(c);</span>
            }
        }
<span class="nc" id="L189">        return sb.toString();</span>
    }
    
    /**
     * 
     * @param s 
     * @return 
     */
    static String toXMLBuffer(byte barr[]) {
<span class="nc bnc" id="L198" title="All 4 branches missed.">        if (barr == null || barr.length == 0) {</span>
<span class="nc" id="L199">            return &quot;&quot;;</span>
        }
<span class="nc" id="L201">        StringBuilder sb = new StringBuilder(2*barr.length);</span>
<span class="nc bnc" id="L202" title="All 2 branches missed.">        for (int idx = 0; idx &lt; barr.length; idx++) {</span>
<span class="nc" id="L203">            sb.append(Integer.toHexString(barr[idx]));</span>
        }
<span class="nc" id="L205">        return sb.toString();</span>
    }
    
    /**
     * 
     * @param s 
     * @throws java.io.IOException 
     * @return 
     */
    static byte[] fromXMLBuffer(String s)
    throws IOException {
<span class="nc" id="L216">        ByteArrayOutputStream stream =  new ByteArrayOutputStream();</span>
<span class="nc bnc" id="L217" title="All 2 branches missed.">        if (s.length() == 0) { return stream.toByteArray(); }</span>
<span class="nc" id="L218">        int blen = s.length()/2;</span>
<span class="nc" id="L219">        byte[] barr = new byte[blen];</span>
<span class="nc bnc" id="L220" title="All 2 branches missed.">        for (int idx = 0; idx &lt; blen; idx++) {</span>
<span class="nc" id="L221">            char c1 = s.charAt(2*idx);</span>
<span class="nc" id="L222">            char c2 = s.charAt(2*idx+1);</span>
<span class="nc" id="L223">            barr[idx] = Byte.parseByte(&quot;&quot;+c1+c2, 16);</span>
        }
<span class="nc" id="L225">        stream.write(barr);</span>
<span class="nc" id="L226">        return stream.toByteArray();</span>
    }
    
    /**
     * 
     * @param buf 
     * @return 
     */
    static String toCSVBuffer(byte barr[]) {
<span class="pc bpc" id="L235" title="1 of 4 branches missed.">        if (barr == null || barr.length == 0) {</span>
<span class="fc" id="L236">            return &quot;&quot;;</span>
        }
<span class="fc" id="L238">        StringBuilder sb = new StringBuilder(barr.length + 1);</span>
<span class="fc" id="L239">        sb.append('#');</span>
<span class="fc bfc" id="L240" title="All 2 branches covered.">        for(int idx = 0; idx &lt; barr.length; idx++) {</span>
<span class="fc" id="L241">            sb.append(Integer.toHexString(barr[idx]));</span>
        }
<span class="fc" id="L243">        return sb.toString();</span>
    }
    
    /**
     * Converts a CSV-serialized representation of buffer to a new
     * ByteArrayOutputStream.
     * @param s CSV-serialized representation of buffer
     * @throws java.io.IOException 
     * @return Deserialized ByteArrayOutputStream
     */
    static byte[] fromCSVBuffer(String s)
    throws IOException {
<span class="nc bnc" id="L255" title="All 2 branches missed.">        if (s.charAt(0) != '#') {</span>
<span class="nc" id="L256">            throw new IOException(&quot;Error deserializing buffer.&quot;);</span>
        }
<span class="nc" id="L258">        ByteArrayOutputStream stream =  new ByteArrayOutputStream();</span>
<span class="nc bnc" id="L259" title="All 2 branches missed.">        if (s.length() == 1) { return stream.toByteArray(); }</span>
<span class="nc" id="L260">        int blen = (s.length()-1)/2;</span>
<span class="nc" id="L261">        byte[] barr = new byte[blen];</span>
<span class="nc bnc" id="L262" title="All 2 branches missed.">        for (int idx = 0; idx &lt; blen; idx++) {</span>
<span class="nc" id="L263">            char c1 = s.charAt(2*idx+1);</span>
<span class="nc" id="L264">            char c2 = s.charAt(2*idx+2);</span>
<span class="nc" id="L265">            barr[idx] = Byte.parseByte(&quot;&quot;+c1+c2, 16);</span>
        }
<span class="nc" id="L267">        stream.write(barr);</span>
<span class="nc" id="L268">        return stream.toByteArray();</span>
    }
    public static int compareBytes(byte b1[], int off1, int len1, byte b2[], int off2, int len2) {
        int i;
<span class="nc bnc" id="L272" title="All 4 branches missed.">        for(i=0; i &lt; len1 &amp;&amp; i &lt; len2; i++) {</span>
<span class="nc bnc" id="L273" title="All 2 branches missed.">            if (b1[off1+i] != b2[off2+i]) {</span>
<span class="nc bnc" id="L274" title="All 2 branches missed.">                return b1[off1+i] &lt; b2[off2+i] ? -1 : 1;</span>
            }
        }
<span class="nc bnc" id="L277" title="All 2 branches missed.">        if (len1 != len2) {</span>
<span class="nc bnc" id="L278" title="All 2 branches missed.">            return len1 &lt; len2 ? -1 : 1;</span>
        }
<span class="nc" id="L280">        return 0;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>